# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with apiviz

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-core
Version:        1.1.5
Release:        3%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Core
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-core-1.1.5/ && tar cjf jboss-ejb3-core-1.1.5.tar.bz2 jboss-ejb3-core-1.1.5
Source0:        jboss-ejb3-core-1.1.5.tar.bz2
Source1:        jboss-ejb3-core-jpp-depmap.xml
Source2:        jboss-ejb3-core-settings.xml
Patch0:         jboss-ejb3-core-no-apiviz.patch
Patch1:         jboss-ejb3-core-EjbLinkDemandMetaData.patch
Patch2:         jboss-ejb3-core-SimplePolicyRegistration.patch
# set the scope of jnpserver to compile
Patch3:         jboss-ejb3-core-pom_xml.patch
Patch4:         jboss-ejb3-core-no-jboss-embedded.patch
Patch5:         jboss-ejb3-core-jboss-bootstrap.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       gnu-trove
Requires:       hibernate3
Requires:       hibernate3-annotations
Requires:       hibernate3-entitymanager
Requires:       javassist
Requires:       jaxws_2_1_api
Requires:       jboss-aop2
Requires:       jboss-bootstrap
Requires:       jboss-cache-core
Requires:       jboss-cluster-ha-client
Requires:       jboss-cluster-ha-server-api
Requires:       jboss-deployers
Requires:       jboss-ejb-3.0-api
Requires:       jboss-ejb3-cache
Requires:       jboss-ejb3-common
Requires:       jboss-ejb3-endpoint
Requires:       jboss-ejb3-ext-api
Requires:       jboss-ejb3-ext-api-impl
Requires:       jboss-ejb3-interceptors
Requires:       jboss-ejb3-metadata
Requires:       jboss-ejb3-proxy-clustered
Requires:       jboss-ejb3-proxy-impl
Requires:       jboss-ejb3-proxy-spi
Requires:       jboss-ejb3-security
Requires:       jboss-ejb3-timerservice-spi
Requires:       jboss-ejb3-transactions
Requires:       jboss-common-logging-spi
Requires:       jboss-integration
Requires:       jboss-jacc-1.1-api
Requires:       jboss-jad-1.2-api
Requires:       jboss-jca-1.5-api
Requires:       jboss-jms-1.1-api
Requires:       jboss-jpa-deployers
Requires:       jboss-logbridge
Requires:       jboss-metadata
Requires:       jboss-microcontainer2
Requires:       jboss-naming
Requires:       jboss-remoting-aspects
Requires:       jboss-security-spi
Requires:       jboss-vfs2
Requires:       jboss5-libs
Requires:       jbosssx2
Requires:       jbossws-spi
Requires:       jpackage-utils
Requires:       quartz
Requires:       servlet_2_5_api
Requires:       ws_metadata_2_0_api
BuildRequires:  apache-commons-parent
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-shared-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
%if %with apiviz
BuildRequires:  apiviz
%endif
BuildRequires:  glassfish-javamail
BuildRequires:  jbossts
BuildRequires:  jboss-aspects-test
BuildRequires:  jboss-ejb3-test
BuildRequires:  jboss-server-manager
BuildRequires:  jboss-test
BuildRequires:  junit44
BuildRequires:  sun-saaj-1.3-api
BuildRequires:  gnu-trove
BuildRequires:  hibernate3
BuildRequires:  hibernate3-annotations
BuildRequires:  hibernate3-entitymanager
BuildRequires:  javassist
BuildRequires:  jaxws_2_1_api
BuildRequires:  jboss-aop2
BuildRequires:  jboss-bootstrap
BuildRequires:  jboss-cache-core
BuildRequires:  jboss-cluster-build
BuildRequires:  jboss-cluster-ha-client
BuildRequires:  jboss-cluster-ha-server-api
BuildRequires:  jboss-deployers
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-cache
BuildRequires:  jboss-ejb3-common
BuildRequires:  jboss-ejb3-endpoint
BuildRequires:  jboss-ejb3-ext-api
BuildRequires:  jboss-ejb3-ext-api-impl
BuildRequires:  jboss-ejb3-interceptors
BuildRequires:  jboss-ejb3-metadata
BuildRequires:  jboss-ejb3-proxy-clustered
BuildRequires:  jboss-ejb3-proxy-impl
BuildRequires:  jboss-ejb3-proxy-spi
BuildRequires:  jboss-ejb3-security
BuildRequires:  jboss-ejb3-timerservice-spi
BuildRequires:  jboss-ejb3-transactions
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-integration
BuildRequires:  jboss-jacc-1.1-api
BuildRequires:  jboss-jad-1.2-api
BuildRequires:  jboss-jca-1.5-api
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  jboss-jpa-deployers
BuildRequires:  jboss-logbridge
BuildRequires:  jboss-metadata
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
BuildRequires:  jboss-parent
BuildRequires:  jboss-remoting-aspects
BuildRequires:  jboss-security-spi
BuildRequires:  jboss-vfs2
BuildRequires:  jboss5-libs
BuildRequires:  jbosssx2
BuildRequires:  jbossws-spi
BuildRequires:  jbossws
BuildRequires:  jbossts
BuildRequires:  quartz
BuildRequires:  servlet_2_5_api
BuildRequires:  ws_metadata_2_0_api
BuildRequires:  objectweb-asm
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB core.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q 
%if %without apiviz
%patch0 -b .sav0
%endif
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/javax/security/jaas/1.0.01/
ln -sf %{_jvmdir}/java/jre/lib/rt.jar $MAVEN_REPO_LOCAL/javax/security/jaas/1.0.01/jaas-1.0.01.jar
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/jboss-ejb3-core.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jboss-ejb3-core-client.jar %{buildroot}%{_javadir}/%{name}-client-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar | sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 %{name} %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-client-%{version}.jar
%{_javadir}/%{name}-client.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Nov 01 2010 David Walluck <dwalluck@redhat.com> 0:1.1.5-3
- don't Requires: jboss-ejb3-build

* Wed Sep 22 2010 David Walluck <dwalluck@redhat.com> 0:1.1.5-2
- remove some incorrect Requires

* Thu Jan 21 2010 David Walluck <dwalluck@redhat.com> 0:1.1.5-1
- 1.1.5
